#!/bin/zsh

cgi_post
cgi_refdata

filter="&filter=$_REF[\"filter\"]"
filtertype="&filtertype=$_REF[\"filtertype\"]"
order="&order=$_REF[\"order\"]"

card="$_POST[\"card\"]"
tempfile="$_DATA/temp/$card"
cardfile="$_DATA/vcard/$card"
attfile="$_DATA/mappings/attendance"

echo "BEGIN:VCARD\r" >"$tempfile"
echo "VERSION:4.0\r" >>"$tempfile"
echo "N:$_POST[\"0N\"];$_POST[\"1N\"];$_POST[\"2N\"];$_POST[\"3N\"];$_POST[\"4N\"]\r" >>"$tempfile"
echo "UID:$_POST[\"UID\"]\r" >>"$tempfile"
for field in $VCF_FIELDS; do
  value="$_POST[\"$field\"]"
  n=0
  while [ -n "$value" ]; do
    value="$(echo "$value" |sed -r ':a;N;$!ba;s:\n:\\\\n:g;s:\r:\\\\r:g')"
    echo "${field}:${value}\r"
    value="$_POST[\"$field$n\"]"
    n=$(($n + 1))
  done
done >>"$tempfile"

case "$_POST[\"action\"]" in
  addfield)
    echo "$_POST[\"newfield\"]:\r" >>"$tempfile"
    echo "END:VCARD\r" >>"$tempfile"
    echo -n "Location: http://$HTTP_HOST/?page=attendees${filter}${filtertype}${order}&edit=$card\n\n"
    ;;
  update)
    attendance=()
    for att in attendance attendance{0..100}; do
      [ -n "$_POST[\"$att\"]" ] && attendance+=("$_POST[\"$att\"]")
    done
    sed -rn 's:^(.+)'$card'$:\1:p' "$attfile" |while read course; do
      touch "$_DATA/ical/$course"
    done
    sed -i -r '/^(.+)\t'$card'$/d' "$attfile"
    for each in $attendance; do
      echo "$each\t$card" >>"$attfile"
    done

    echo "END:VCARD\r" >>"$tempfile"
    mv "$tempfile" "$cardfile"
    echo -n "Location: http://$HTTP_HOST/?page=attendees${filter}${filtertype}${order}#$card\n\n"
    ;;
  cancel)
    rm "$tempfile"
    [ -f "$cardfile" ] \
      && echo -n "Location: http://$HTTP_HOST/?page=attendees${filter}${filtertype}${order}#$card\n\n" \
      || echo -n "Location: http://$HTTP_HOST/?page=attendees${filter}${filtertype}${order}\n\n"
    ;;
  delete)
    rm "$tempfile" "$cardfile"
    echo -n "Location: http://$HTTP_HOST/?page=attendees${filter}${filtertype}${order}\n\n"
    ;;
esac
